# Java `String.startsWith()`示例

> 原文： [https://howtodoinjava.com/java/string/java-string-startswith-example/](https://howtodoinjava.com/java/string/java-string-startswith-example/)

[Java 字符串](https://howtodoinjava.com/java-string/)`startsWith()`方法用于检查字符串的前缀。 它验证给定的字符串是否以参数字符串开头。

`startsWith()`方法是重载方法，具有两种形式：

1.  **`boolean startsWith(String str)`** – 如果`str`是字符串的前缀，则返回`true`。
2.  **`boolean startsWith(String str, int fromIndex)`** – 如果字符串从指定索引`fromIndex`开始以`str`开头，则返回`true`。

## 1\. `String.startsWith(String str)`示例

检查字符串是否以前缀参数字符串开头的 Java 程序。

```java
public class StringExample 
{
    public static void main(String[] args) 
    {
        String blogName = "howtodoinjava.com";

        System.out.println( blogName.startsWith("how") );               //true

        System.out.println( "howtodoinjava.com".startsWith("howto") );  //true

        System.out.println( "howtodoinjava.com".startsWith("hello") );  //false
    }
}

```

程序输出。

```java
true
true
false

```

> `String.startsWith()`方法不接受**正则表达式**作为参数。 如果我们以*正则表达式*模式作为参数传递，它将仅被视为普通字符串。

#### 1.1 不允许使用`null`方法参数

请注意，不允许`null`作为方法参数。 如果传递了`null`，它将抛出`NullPointerException`。

```java
public class StringExample 
{
    public static void main(String[] args) 
    {
    	String blogName = "howtodoinjava.com";

        blogName.startsWith(null);
    }
}

```

程序输出：

```java
Exception in thread "main" java.lang.NullPointerException
	at java.lang.String.startsWith(String.java:1392)
	at java.lang.String.startsWith(String.java:1421)
	at com.StringExample.main(StringExample.java:9)

```

## 2\. Java `String.startsWith(String str, int fromIndex)`示例

与`startsWith(str)`方法类似，此方法也检查前缀。 区别在于它检查从指定的`fromIndex`开始的前缀`str`。

此方法也不接受该方法的`null`参数。

```java
public class StringExample 
{
    public static void main(String[] args) 
    {
        String blogName = "howtodoinjava.com";

        System.out.println( blogName.startsWith("howto", 0) );                  //true

        System.out.println( "howtodoinjava.com".startsWith("howto", 2) );       //false
    }
}

```

程序输出：

```java
true
false

```

参考：

[Java `String`文档](https://docs.oracle.com/javase/10/docs/api/java/lang/String.html)