# Java 仅允许字母数字字符的正则表达式

> 原文： [https://howtodoinjava.com/regex/regex-alphanumeric-characters/](https://howtodoinjava.com/regex/regex-alphanumeric-characters/)

我们可以使用给定的[正则表达式](https://howtodoinjava.com/java-regular-expression-tutorials/)来验证用户输入，使其仅允许**字母数字**字符。 字母数字字符都是字母和数字，即**字母`A–Z`，`a–z`和数字`0–9`**。

## 1\. 字母数字正则表达式模式

使用**字母数字正则表达式**，解决方案非常简单。 字符类可以设置允许的字符范围。 添加了一个可重复一次或多次重复字符类的量词，并将定位符绑定到字符串的开头和结尾的锚点，我们就可以开始了。

> 正则表达式：`^[a-zA-Z0-9]+$`

## 2\. 字母数字正则表达式示例

```java
List<String> names = new ArrayList<String>();

names.add("Lokesh");  
names.add("LOkesh123");  
names.add("LOkesh123-");  //Incorrect

String regex = "^[a-zA-Z0-9]+$";

Pattern pattern = Pattern.compile(regex);

for (String name : names)
{
  Matcher matcher = pattern.matcher(name);
  System.out.println(matcher.matches());
}

```

程序输出。

```java
true
true
false

```

了解基础知识非常容易。是吧？

学习愉快！