# Java 7 中数字字面值的下划线

> 原文： [https://howtodoinjava.com/java7/improved-formatted-numbers-in-java-7/](https://howtodoinjava.com/java7/improved-formatted-numbers-in-java-7/)

[Java 7](https://howtodoinjava.com/java7/java-7-changes-features-and-enhancements/) 通过允许**下划线数字**，以非常令人愉快的方式改进了数字字面值格式。 它使读取数字变得容易，并且当我们在应用程序日志中编写数字字面值时，它们看起来不错。

例如，如果我们必须读取数字“**1000000**”，那么它乍看之下有多方便。 不多吧？

我们有一种阅读`10,00,000`格式的数字的习惯。 好消息是 Java 已经开始支持以这种格式写数字。 好吧，不完全是这样，而是匹配的格式。

## 1\. 数字字面值下划线 – 示例

在 Java 7 发布之后，现在我们可以像上面这样写上面的数字：`10_00_000`。 足够好了，不是！

下面给出了带有下划线的新格式数字的 Java 程序。

```java
public class ImprovedNumbersInJava7
{
	@SuppressWarnings("unused")
	public static void main(String[] args)
	{
		/**
		 * Supported in int
		 * */
		int improvedInt = 10_00_000;

		/**
		 * Supported in float
		 * */
		float improvedFloat = 10_00_000f;

		/**
		 * Supported in long
		 * */
		float improvedLong = 10_00_000l;

		/**
		 * Supported in double
		 * */
		float improvedDouble = 10_00_000;
	}
}

```

## 2\. 数字字面值下划线 – 注释

1.  下划线只能放在数字之间。 我们不能在小数点“`.`”旁边加上下划线。
2.  允许连续的下划线。 `10___00`是有效数字。
3.  不允许在数字的最后加上下划线。`1000_`不是有效数字。 它将产生编译时错误。
4.  在 Java 中，允许在变量名称之前加下划线。 当您在数字开头加上下划线时，请当心。 它是一个变量，而不是数字。

学习愉快！

阅读更多：

[Java 文档](https://docs.oracle.com/javase/7/docs/technotes/guides/language/underscores-literals.html)