# TypeScript 模板字符串

> 原文： [https://howtodoinjava.com/typescript/template-strings/](https://howtodoinjava.com/typescript/template-strings/)

模板字符串是常规 JavaScript 字符串，其中包含反引号字符（` ``` `java），这些字符带有以`${ }`表示的占位符。 在运行时，您的代码将占位符替换为实际值。

## 模板字符串示例

我们来看一个非常基本的模板字符串示例。 在此示例中，在运行时，代码将占位符替换为变量的实际值。 称为**变量替换**。

```java
const name: String = 'Lokesh';
const age: number = 35;

let message: string = `My name is ${ name } and my age is ${ age }`;

console.log(message);		//My name is Lokesh and my age is 35

```

## 模板字符串可以是多行

与使用加号（`+`）来连接多行字符串的常规字符串不同，**模板字符串不需要加号**。

```java
const name: String = 'Lokesh';
const age: number = 35;

let message: string = `My name is 
						${ name } 
						and
						my age is 
						${ age }`;

//Output

My name is 
Lokesh 
and
my age is 
35

```

请注意，多行模板字符串输出以新行字符格式化的**字符串**。

将我的问题放在评论部分。

学习愉快！