# Log4j2 – 有用的转换模式示例

> 原文： [https://howtodoinjava.com/log4j2/useful-conversion-pattern-examples/](https://howtodoinjava.com/log4j2/useful-conversion-pattern-examples/)

下面的 log4j2 转换模式仅供参考，这样您和我就不会在每次创建/编辑 log4j 配置文件时浪费时间来构建这些模式。

我正在使用下面的日志语句来生成日志。

```java
LOGGER.debug("Debug Message Logged !!");
LOGGER.info("Info Message Logged !!");

```

现在，我将列出不同的日志模式及其各自生成的输出。

## `%d [%p] %c{1} – %m%n`

使用它进行简单的日志记录，即日期，级别，记录器，消息。 它将生成以下输出：

```java
2016-06-20 19:18:02,958 [DEBUG] Log4j2HelloWorldExample - Debug Message Logged !!
2016-06-20 19:18:02,959 [INFO] Log4j2HelloWorldExample - Info Message Logged !!

```

## `%d [%-6p] %c{1} – %m%n`

使用它可以以漂亮的打印记录器级别进行简单记录。 它将生成以下输出：

```java
2016-06-20 19:21:05,271 [DEBUG ] Log4j2HelloWorldExample - Debug Message Logged !!
2016-06-20 19:21:05,272 [INFO  ] Log4j2HelloWorldExample - Info Message Logged !!

```

## `%d [%-6p] %c{1} – %m%n`

使用它来打印完整的包级别。 它将生成以下输出：

```java
2016-06-20 19:22:05,379 [DEBUG ] com.howtodoinjava.log4j2.examples.Log4j2HelloWorldExample - Debug Message Logged !!
2016-06-20 19:22:05,380 [INFO  ] com.howtodoinjava.log4j2.examples.Log4j2HelloWorldExample - Info Message Logged !!

```

## `%d [%-6p] %c{3} – %m%n`

使用它最多可打印两个级别的包。 它将生成以下输出：

```java
2016-06-20 19:23:48,202 [DEBUG ] log4j2.examples.Log4j2HelloWorldExample - Debug Message Logged !!
2016-06-20 19:23:48,204 [INFO  ] log4j2.examples.Log4j2HelloWorldExample - Info Message Logged !!

```

## `%d{yyyy/MM/dd HH:mm:ss,SSS} [%-6p] %c{1} – %m%n`

用于自定义日期格式。 它将生成以下输出：

```java
2016/06/20 19:24:45,076 [DEBUG ] Log4j2HelloWorldExample - Debug Message Logged !!
2016/06/20 19:24:45,078 [INFO  ] Log4j2HelloWorldExample - Info Message Logged !!

```

## `%d [%-6p] %C{1}.%M(%F:%L) – %m%n`

将其用于调用方类，方法，源文件和行号。 它将生成以下输出：

```java
2016-06-20 19:25:42,249 [DEBUG ] Log4j2HelloWorldExample.methodOne(Log4j2HelloWorldExample.java:14) - Debug Message Logged !!
2016-06-20 19:25:42,251 [INFO  ] Log4j2HelloWorldExample.methodOne(Log4j2HelloWorldExample.java:15) - Info Message Logged !!

```

## `%sn %d{yyyy/MM/dd HH:mm:ss,SSS} %r [%-6p] [%t] %c{3} %C{3}.%M(%F:%L) – %m%n`

使用它来捕获上面讨论的所有内容。 它将生成以下输出：

```java
1 2016/06/20 19:27:03,595 620 [DEBUG ] [main] log4j2.examples.Log4j2HelloWorldExample log4j2.examples.Log4j2HelloWorldExample.main(Log4j2HelloWorldExample.java:14) - Debug Message Logged !!
2 2016/06/20 19:27:03,597 622 [INFO  ] [main] log4j2.examples.Log4j2HelloWorldExample log4j2.examples.Log4j2HelloWorldExample.main(Log4j2HelloWorldExample.java:15) - Info Message Logged !!

```

根据您的需要随意更改和使用任何模式。

学习愉快！