# Python `max()`和`min()`– 在列表或数组中查找最大值和最小值

> 原文： [https://howtodoinjava.com/python/max-min/](https://howtodoinjava.com/python/max-min/)

Python 示例使用`max()`和`min()`方法在可比较元素的集合（例如列表，集合或数组）中找到最大（或最小）的项目。

## 1\. Python `max()`函数

`max()`函数用于：

1.  计算在其参数中传递的最大值。
2.  如果字符串作为参数传递，则在字典上的最大值。

#### 1.1 查找数组中的最大整数

```py
>>> nums = [1, 8, 2, 23, 7, -4, 18, 23, 42, 37, 2]

>>> max( nums )

42		#Max value in array

```

#### 1.2 查找数组中的最大字符串

```py
>>> blogName = ["how","to","do","in","java"]

>>> max( blogName )

'to'		#Largest value in array

```

#### 1.3 查找最大键或值

有点复杂的结构。

```py
>>> prices = {
   'how': 45.23,
   'to': 612.78,
   'do': 205.55,
   'in': 37.20,
   'java': 10.75
}

>>> max( prices.values() )
612.78

>>> max( prices.keys() ) 	#or max( prices ). Default is keys().
'to'

```

## 2\. Python `min()`函数

此函数用于：

1.  计算在其参数中传递的最小值。
2.  如果字符串作为参数传递，则在字典上的最小值。

#### 2.1 查找数组中的最小整数

```py
>>> nums = [1, 8, 2, 23, 7, -4, 18, 23, 42, 37, 2]

>>> min( nums )

-4		#Min value in array

```

#### 2.2 查找数组中的最小字符串

```py
>>> blogName = ["how","to","do","in","java"]

>>> min( blogName )

'do'		#Smallest value in array

```

#### 2.3 查找最小键或值

A little complex structure.

```py
>>> prices = {
   'how': 45.23,
   'to': 612.78,
   'do': 205.55,
   'in': 37.20,
   'java': 10.75
}

>>> min( prices.values() )
10.75

>>> min( prices.keys() ) 	#or min( prices ). Default is keys().
'do'

```

学习愉快！